package proc;

import java.util.ArrayList;

public class ProcRestriction extends Proc {
	public String channel;
	Proc process;

	public ProcRestriction(String channel, Proc process) {
		this.type = RES;
		this.channel = channel;
		this.process = process;
	}

	public String toString() {
		return "[" + channel + "]" + process;
	}

	public ArrayList<Transition> transitions() {
		if(trans != null) return trans;
		
		trans = new ArrayList<Transition>();
		for(Transition t : process.transitions() )
			if(!t.channel.equals(this.channel)) {
				Transition newt = t.clone();
				for(ProbOfProc pp : newt.dist)
					pp.process = new ProcRestriction(channel, pp.process);
				trans.add(newt);
			}
		
		return trans;
	}
}

